from __future__ import generators
import plus
import Arenas
import Hazards
import random
#import Gooey
import math

class RingArena(Arenas.SuperArena):
    "Sunrise is upon us."
    name = "Sakura Sunrise temple"
    preview = "temple/templepre.bmp"
    game_types = ['DEATHMATCH', 'BATTLE ROYAL']

    def __init__(self):
        Arenas.SuperArena.__init__(self, "Arenas/temple/temple.gmf")
        #plus.Arena.__init__(self, "")
        plus.setBackColor(0,0,0)
        fmod = 0.015
        degrad = 0.01745
        self.AddStaticCamera("Door Cam", (1.8, 13, -17), (40*degrad, 0), degrad*62)
        self.AddStaticCamera("Birds Eye", (0, 55.8, 2), (90*degrad, 90*degrad), degrad*37)
        self.AddStaticCamera("Random Cam", (13, 9, -17), (.367, -40*degrad), degrad*55)

        self.AddWatchCamera("Overhead", (2.5, 10, -15), (20, 30, 60*degrad, 20*degrad))
        self.AddWatchCamera("Roboteer View", (11.6, 11.5, 22.5), (20, 30, 60*degrad, 20*degrad))
        self.AddWatchCamera("Arena cam 1", (-14, 9, 18), (20, 30, 60*degrad, 20*degrad))
        self.AddWatchCamera("Arena cam 2", (-9.3, 8, -14.7), (16, 22, 30*degrad, 20*degrad))

        self.AddSound = plus.createSound("Sounds/rwarenaloop4.wav", False, (0, 0, 0))
        plus.loopSound(self.AddSound)
        self.botinzone = 0
        self.botinzone2 = 0
        self.flippertimer = 0
        self.pittimer = 0
        self.players = ()
        # POSITION TRACKER: set up text box and turn off immobility for hazard positioning.
        # self.tauntbox = Gooey.Plain("taunt", 10, 175, 640, 175)
        # tbox = self.tauntbox.addText("taunt1", 10, 0, 640, 15)
        # tbox.setText("")
        # plus.practice(1)

    def __del__(self):
        if self.AddSound:
            plus.stopSound(self.AddSound)
            plus.removeSound(self.AddSound)
        Arenas.SuperArena.__del__(self)

    def AddShadowReceivers(self):
        pass
        
    def HazardsOn(self, on):
        # walls
        self.AddCollisionLine((-12.5, -12.5), (-12.5, -2))
        self.AddCollisionLine((-12.5, -2), (-11.75, -2))
        self.AddCollisionLine((-11.75, -2), (-11.75, 2))
        self.AddCollisionLine((-11.75, 2), (-12.5, 2))
        self.AddCollisionLine((-12.5, 2), (12.5, 2))
        self.AddCollisionLine((-12.5, -12.5), (12.5, -12.5))
        self.AddCollisionLine((12.5, -12.5), (12.5, -2))
        self.AddCollisionLine((12.5, -2), (11.75, -2))
        self.AddCollisionLine((11.75, -2), (11.75, 2))
        self.AddCollisionLine((11.75, 2), (12.5, 2))
        self.AddCollisionLine((12.5, -12.5), (12.5, 12.5))
        
        self.AddPOV(0, (-13.5, -3), (1, 2))
        self.AddPOV(1, (-10.75, -3), (0, 3))
        self.AddPOV(2, (-13.5, 3), (0, 3))
        self.AddPOV(3, (-10.75, 3), (1, 2))
        self.AddPOV(4, (13.5, -3), (5, 6))
        self.AddPOV(5, (10.75, -3), (4, 7))
        self.AddPOV(6, (13.5, 3), (4, 7))
        self.AddPOV(7, (10.75, 3), (5, 6))
        if on:
            self.saw1 = self.GetHinge("Hinge02")
            self.saw1.SetAutoLocks(False, False)
            self.saw1.SetPowerSettings(100, 50)
            self.saw1.Lock(False)
            self.saw1.SetDirection(-100)
            self.SetSubMaterial('saw1_display_sawblade', 'metal', 1.9)
            
            self.saw2 = self.GetHinge("Hinge03")
            self.saw2.SetAutoLocks(False, False)
            self.saw2.SetPowerSettings(100, 50)
            self.saw2.Lock(False)
            self.saw2.SetDirection(-100)
            self.SetSubMaterial('saw2_display_sawblade.001', 'metal', 1.9)
            
            self.saw3 = self.GetHinge("Hinge04")
            self.saw3.SetAutoLocks(False, False)
            self.saw3.SetPowerSettings(100, 50)
            self.saw3.Lock(False)
            self.saw3.SetDirection(-100)
            self.SetSubMaterial('saw3_display_sawblade.002', 'metal', 1.9)
            
            self.saw4 = self.GetHinge("Hinge01")
            self.saw4.SetAutoLocks(False, False)
            self.saw4.SetPowerSettings(100, 50)
            self.saw4.Lock(False)
            self.saw4.SetDirection(100)
            self.SetSubMaterial('saw4_display_sawblade.003', 'metal', 1.9)
            
            self.saw5 = self.GetHinge("Hinge05")
            self.saw5.SetAutoLocks(False, False)
            self.saw5.SetPowerSettings(100, 50)
            self.saw5.Lock(False)
            self.saw5.SetDirection(100)
            self.SetSubMaterial('saw5_display_sawblade.004', 'metal', 1.9)
            
            self.saw6 = self.GetHinge("Hinge06")
            self.saw6.SetAutoLocks(False, False)
            self.saw6.SetPowerSettings(100, 50)
            self.saw6.Lock(False)
            self.saw6.SetDirection(100)
            self.SetSubMaterial('saw6_display_sawblade.005', 'metal', 1.9)
        else:
            # hazards should be in their "hidden" position
            pass
        return Arenas.SuperArena.HazardsOn(self, on)

    def Activate(self, on):    
        if on: self.players = plus.getPlayers()
        return Arenas.SuperArena.Activate(self, on)
        
    def Introduction(self):
        sounds = self.intro_sounds
        
        # set initial camera & fade from black
        plus.setCameraPosition(-45,35,-45)
        plus.setCameraRotation(0.4012, 0.78539)
        plus.setCameraFOV(0.7753)
        plus.fadeFromBlack(.25)

        #start playing music loop
        self.intro_music = plus.createSound("Sounds/announcers/rwsilence.wav", False, (0,0,0))
        plus.setVolume(self.intro_music, 0, 0)
        plus.loopSound(self.intro_music)
        yield .25
        
        #load all sounds now to decrease lag later
        sounds['crowd'] = plus.createSound("Sounds/crowd/LoudCheer_Loop.wav", False, (0,0,0))
        
        arenaOpt = ("Sounds/announcers/rwringintro1.wav", "Sounds/announcers/rwringintro2.wav")
        sounds['arena'] = plus.createSound(random.choice(arenaOpt), False, (0,0,0))
        genericOpt = ("rwsilence.wav", "rwsilence.wav", "rwsilence.wav", "rwsilence.wav", "rwsilence.wav", "rwsilence.wav", "Irwsilence.wav", "rwsilence.wav")
        sounds['generic'] = plus.createSound("Sounds/announcers/"+random.choice(genericOpt), False, (0,0,0))
        botOpt = ("Bots_YouCanFeelTension.wav", "Bots_ColdChill.wav", "Bots_FansLoveTheseBots.wav", "Bots_SeeingInterestingDesigns.wav", "Bots_CrowdPoisedBotsArmed.wav")
        sounds['bots'] = plus.createSound("Sounds/announcers/"+random.choice(botOpt), False, (0,0,0))
        
        #intro cam, welcom comment
        plus.playSound(sounds['arena'])
        plus.fadeInToLoop(sounds['crowd'], -100, 800)
        plus.animateCamera((-30,25,-30), (0.4012, 0.78539), 0.7753, (30,25,-30), (0.4012, -0.78539), 0.7753, 0, 8)
        yield 2
        plus.fadeOutLoop(sounds['crowd'], 8000)
        yield 1
        
        #play a generic (or specific) secondary comment
        plus.playSound(sounds['generic'])
        yield 5

        players = plus.getPlayers()
        pcount = len(players)
        delaytime = 10.5 - pcount
        
        if 0 in players:
            #bot 1 cam                                                                                                                                                                                                                              
            plus.animateCamera((-5.57326,12,-4.16246), (0.612217,-2.45323), 0.825, (-4.44016,10.5,-3.44161), (0.203219,-2.19922), 0.825, 0, delaytime)
            yield delaytime
            
        if 1 in players:
            #bot 2 cam
            plus.animateCamera((4.44016,12,3.44161), (0.612217,0.88243), 0.8862, (5.57326,10.5,4.16246), (0.203219,0.62842), 0.8862, 0, delaytime)
            yield delaytime
            
        if 2 in players:
            #bot 3 cam
            plus.animateCamera((-4.16246,12,5.57326), (0.612217,-0.88243), 0.9862, (-3.44161,10.5,4.44016), (0.203219,-0.62842), 0.9862, 0, delaytime)
            yield delaytime
            
        if 3 in players:
            #bot 4 cam
            plus.animateCamera((4.16246,12,-5.57326), (0.612217,2.45323), 1.1, (3.44161,10.5,-4.44016), (0.203219,2.19922), 1.1, 0, delaytime)
            yield delaytime
            
        #fade out music
        plus.fadeOutLoop(self.intro_music, 2000)
        yield 2
        
        # done
        yield 0
        
    def Tick(self):
        for each in self.players:
            if plus.getLocation(each)[1] < 4.5:
                plus.eliminatePlayer(each)        
        return Arenas.SuperArena.Tick(self)

    def ZoneEvent(self, direction, id, robot, chassis):
        if id==1 and direction==1:
            self.botinzone += 1
        elif id==1 and direction==-1:
            self.botinzone -= 1
        return True

Arenas.register(RingArena)
